# std::shared_ptr::operator=

From cppreference.com
< cpp‎ | memory‎ | shared ptr

shared_ptr& operator=( const shared_ptr& r ); | (1) |
template< class Y > shared_ptr& operator=( const shared_ptr<Y>& r ); | (1) |
shared_ptr& operator=( shared_ptr&& r ); | (2) |
template< class Y > shared_ptr& operator=( shared_ptr<Y>&& r ); | (2) |
template< class Y > shared_ptr& operator=( std::auto_ptr<Y>&& r ); | (3) |
template< class Y, class Deleter > shared_ptr& operator=( std::unique_ptr<Y,Deleter>&& r ); | (4) |

Replaces the managed object with the one managed by `r`.

If `*this` already owns an object and it is the last `shared_ptr` owning it, and `r` is not the same as `*this`, the object is destroyed through the owned deleter.

1) Shares ownership of the object managed by `r`. If `r` manages no object, `*this` manages no object too. Equivalent to shared_ptr<T>(r).swap(*this).

2) Move-assigns a `shared_ptr` from `r`. After the assignment, *this contains a copy of the previous state of `r`, `r` is empty. Equivalent to shared_ptr<T>(std::move(r)).swap(*this).

3) Transfers the ownership of the object managed by `r` to `*this`. If `r` manages no object, `*this` manages no object too. After the assignment, `*this` contains the pointer previously held by `r`, and use_count()==1; also `r` is empty. Equivalent to shared_ptr<T>(r).swap(*this).

4) Transfers the ownership of the object managed by `r` to *this. The deleter associated to `r` is stored for future deletion of the managed object. `r` manages no object after the call. Equivalent to shared_ptr<T>(std::move(r)).swap(*this).

### Parameters

r | - | another smart pointer to share the ownership to or acquire the ownership from

### Return value

*this

### Notes

The implementation may meet the requirements without creating a temporary `shared_ptr` object.

### Exceptions

1-2)
`noexcept` specification:
noexcept

3) (none)

4) may throw exception

### Example

| This section is incomplete Reason: no example

### See also

reset | replaces the managed object (public member function)

Retrieved from "http://en.cppreference.com/mwiki/index.php?title=cpp/memory/shared_ptr/operator%3D&oldid=91516"
Categories:

- unconditionally noexcept
- Todo no example

Hidden categories:

- Pages with unreviewed unconditional noexcept template
- Pages with unreviewed noexcept template